From Fedora Project Wiki

(Packaging Progress)
 
(68 intermediate revisions by 3 users not shown)
Line 1: Line 1:
This page is for tracking progress on the packaging of (primarily Java-based) dependencies for Eucalyptus 3.x.  This project will have some overlap with [[JBossAS7|JBossAS7]]Other required Java packages include:
+
This page is for tracking progress on the packaging Eucalyptus 3.x in FedoraWe've been tracking this for three releases now, and the dependency packaging is mostly complete, except for Google Web Toolkit, which we can omit for nowTherefore, it's more useful for the top of this page to summarize the _other_ changes needed to make Eucalyptus build and run on Fedora 18.
  
* Axiom
+
== Remaining tasks ==
* Google Web Toolkit
 
* HA-JDBC
 
* Mule
 
  
The majority of other required packages are either already part of Fedora or are transitive dependencies of the above dependencies.  These packages require large parts of jboss, geronimo, and springframework, among other things. 
+
=== Polish systemd units for eucalyptus services ===
  
SPEC and SRPM files up for review will live under http://downloads.eucalyptus.com/devel/packages/fedora-17/
+
There are three init scripts in eucalyptus:
 +
* eucalyptus-cloud - starts a java service, which may be a Cloud Controller, Walrus, or Storage Controller
 +
* eucalyptus-cc - starts a Cluster Controller (CC), which is a custom httpd instance with wso2-axis2 configured
 +
* eucalyptus-nc - starts a Node Controller (NC), which is a custom httpd instance with wso2-axis2 configured
  
Note:  this page is focused on java dependencies, but for completeness, there are two other necessary packages which Eucalyptus currently maintains but should submit to Fedora:
+
In Fedora 18, we provide systemd units which simple execute the old init scripts, which have been moved to /usr/libexec/eucalyptus.  Ideally, the old init scripts should go away completely.
* axis2c (and axis2c-devel)
 
* rampartc (and rampartc-devel)
 
  
=== Packaging Progress ===
+
=== Create SELinux contexts/policies ===
 +
 
 +
Eucalyptus must run in permissive mode in Fedora 18.  We need to work on policy that will allow it to run in enforcing mode.
 +
 
 +
=== Make Axis2/Java 1.6 work for code generation ===
 +
 
 +
The C code generated by Axis2/Java 1.6.0 does not work with Eucalyptus's currently defined handlers.  Currently, one must use an [http://arg.fedorapeople.org/axis2v14/noarch/ Axis2/Java 1.4 package] to build a tarball of generated code for inclusion in the eucalyptus package.
 +
 
 +
=== Fix the reporting module ===
 +
 
 +
There is a build issue in the reporting module due to the use of Guava 9 in the upstream Eucalyptus build.  For now, the module has been disabled.
 +
 
 +
=== Enable the admin console ===
 +
 
 +
The admin console is based on GWT, which is not yet in Fedora.  It may not be worth the time to build it, though, as Eucalyptus intends to phase out the GWT-based UI.
 +
 
 +
== Packaging Progress ==
  
 
These are the packages still in progress which are necessary for the Eucalyptus build:
 
These are the packages still in progress which are necessary for the Eucalyptus build:
Line 29: Line 43:
 
!Comments
 
!Comments
 
|-
 
|-
|1
+
|27
|wss4j
+
|gwt
|1.5.12
+
|2.4.0
 +
|
 
|
 
|
|{{bz|787738}}
 
 
|[[User:Arg|arg]]
 
|[[User:Arg|arg]]
|'''<span style="color:green">In Rawhide</span>'''
+
|'''<span style="color:red">Clean-up Required</span>'''
|
+
|Required for admin console
 
|-
 
|-
|2
+
|36
|aspectjweaver
+
|josql
|1.6.12
+
|2.2
 
|
 
|
|{{bz|790519}}
+
|<s>{{bz|822832}}</s>
|[[User:Arg|arg]]
+
|[[User:gil|gil]]
 
|'''<span style="color:green">In Rawhide</span>'''
 
|'''<span style="color:green">In Rawhide</span>'''
|Indirect dep: Blocks spring
+
|ActiveMQ deps
 
|-
 
|-
|3
+
|47
|ha-jdbc
+
|mqtt-client
|2.0.16
+
|1.3
 
|
 
|
|{{bz|790256}}
+
|<s>{{bz|853055}}</s>
|[[User:Arg|arg]]
+
|[[User:gil|gil]]
 
|'''<span style="color:green">In Rawhide</span>'''
 
|'''<span style="color:green">In Rawhide</span>'''
|Direct dep
+
|ActiveMQ deps
 
|-
 
|-
|4
+
|48
|hamcrest12
+
|groovy-gram
 
|1.2
 
|1.2
 
|
 
|
|{{bz|790258}}
+
|{{bz|846561}}
|[[User:Arg|arg]]
+
|[[User:gil|gil]]
|'''<span style="color:green">In Rawhide</span>'''
+
|'''<span style="color:orange">Awaiting Review</span>'''
|Direct dep; also blocks ehcache-core
+
|ActiveMQ deps
 
|-
 
|-
|5
+
|49
|hessian
+
|pax-logging
|4.0.7
+
|1.6.9
 
|
 
|
|{{bz|790551}}
+
|<s>{{bz|849469}}</s>
|[[User:Arg|arg]]
+
|[[User:gil|gil]]
 
|'''<span style="color:green">In Rawhide</span>'''
 
|'''<span style="color:green">In Rawhide</span>'''
|Indirect dep: blocks Spring
+
|ActiveMQ deps
 
|-
 
|-
|6
+
|50
|jamonapi
+
|sitemesh
|2.73
+
|2.4.2
 
|
 
|
|{{bz|791222}}
+
|<s>{{bz|853439}}</s>
|[[User:Arg|arg]]
+
|[[User:gil|gil]]
|'''<span style="color:green">In Rawhide</span>'''
+
|'''<span style="color:darkviolet">Skipped</span>'''
|Indirect dep: blocks Spring
+
|ActiveMQ deps. This package was removed from review request queue.
 
|-
 
|-
|7
+
|51
|xml-maven-plugin
+
|apache-commons-primitives
 +
|1.1
 
|
 
|
|
+
|<s>{{bz|832803}}</s>
|{{bz|782250}}
+
|[[User:gil|gil]]
|[[User:Ke4qqq|ke4qqq]]
 
 
|'''<span style="color:green">In Rawhide</span>'''
 
|'''<span style="color:green">In Rawhide</span>'''
|Indirect dep; blocks ehcache-core
+
|ActiveMQ deps
 
|-
 
|-
|8
+
|52
|axis2c
+
|felix-fileinstall
|1.6.0
+
|3.2.0
 
|
 
|
|{{bz|735225}}
+
|<s>{{bz|855192}}</s>
|[[User:Gholms|gholms]]
+
|[[User:gil|gil]]
|'''<span style="color:green">In Rawhide</span>'''
 
|
 
|-
 
|9
 
|rampartc
 
|
 
|1.3.0
 
|{{bz|796462}}
 
|[[User:Gholms|gholms]]
 
|'''<span style="color:green">Approved</span>'''
 
|
 
|-
 
|10
 
|jexcelapi
 
|2.6.12
 
|
 
|{{bz|791312}}
 
|[[User:Arg|arg]]
 
|'''<span style="color:green">In Rawhide</span>'''
 
|Indirect dep: blocks Spring
 
|-
 
|11
 
|axiom
 
|1.2.12
 
|
 
|{{bz|791053}}
 
|[[User:Arg|arg]]
 
|'''<span style="color:green">In Rawhide</span>'''
 
|Direct dep; also blocks axis2
 
|-
 
|12
 
|neethi
 
|3.0.1
 
|
 
|{{bz|794941}}
 
|[[User:Arg|arg]]
 
 
|'''<span style="color:green">In Rawhide</span>'''
 
|'''<span style="color:green">In Rawhide</span>'''
|Indirect dep: blocks axis2
+
|Apache Karaf deps
 
|-
 
|-
|13
+
|53
|XmlSchema
+
|felix-webconsole
|1.4.7
+
|4.0.0
 
|
 
|
|{{bz|794946}}
+
|{{bz|855193}}
|[[User:Arg|arg]]
 
|'''<span style="color:green">In Rawhide</span>'''
 
|Indirect dep: blocks axis2
 
|-
 
|14
 
|apache-commons-ognl
 
|3.0.4
 
|
 
|{{bz|794715}}
 
|[[User:Arg|arg]]
 
|'''<span style="color:green">In Rawhide</span>'''
 
|Indirect dep: blocks mule. Renamed from ognl to apache-commons-ognl during review.
 
|-
 
|15
 
|annogen
 
|0.1.0
 
|
 
|{{bz|790990}}
 
|[[User:Arg|arg]]
 
|'''<span style="color:green">In Rawhide</span>'''
 
|Indirect dep: blocks axis2
 
|-
 
|16
 
|geronimo-commonj
 
|
 
|
 
|{{bz|799392}}
 
|[[User:Jhernand|jhernand]]
 
|'''<span style="color:green">In Rawhide</span>'''
 
|Indirect dep; blocks spring
 
|-
 
|17
 
|netty3.1
 
|3.1.5
 
|
 
|{{bz|795492}}
 
|[[User:Arg|arg]]
 
|'''<span style="color:green">In Rawhide</span>'''
 
|Direct dep
 
|-
 
|18
 
|stax-utils
 
|20110309
 
|
 
|{{bz|794923}}
 
|[[User:Arg|arg]]
 
|'''<span style="color:orange">In Review, on hold</span>'''
 
|Indirect dep; blocks mule -- maybe unnecessary?
 
|-
 
|19
 
|woden
 
|1.0M9
 
|
 
|{{bz|795566}}
 
|[[User:Arg|arg]]
 
|'''<span style="color:green">In Rawhide</span>'''
 
|Indirect dep: blocks axis2; blocked by axiom, XmlSchema
 
|-
 
|20
 
|axis2
 
|1.6.1
 
|
 
|{{bz|802549}}
 
|[[User:Arg|arg]]
 
|'''<span style="color:green">SCM Requested</span>'''
 
|blocked by neethi, woden, XmlSchema
 
|-
 
|21
 
|jboss-connector-1.6-api
 
|1.0.1
 
|
 
|{{bz|801614}}
 
|
 
|'''<span style="color:green">In Rawhide</span>'''
 
|Direct dep
 
|-
 
|22
 
|mule
 
|2.0.2
 
|
 
|
 
|[[User:Arg|arg]]
 
|'''<span style="color:red">Clean-up Required</span>'''
 
|Direct dep
 
|-
 
|23
 
|springframework
 
|3.1.1
 
|
 
|{{bz|804048}}
 
|[[User:Jhernand|jhernand]]
 
|'''<span style="color:green">In Rawhide</span>'''
 
|Direct dep; also blocks mule. Currently only aop, beans, context, expression, instrument, jdbc and transaction modules. More will be added later.
 
|-
 
|24
 
|hibernate-validator
 
|4.2.0
 
|
 
|{{bz|799976}}
 
|[[User:Jhernand|jhernand]]
 
|'''<span style="color:green">In Rawhide</span>'''
 
|Direct dep; also blocks ehcache, hibernate, gwt, ...
 
|-
 
|25
 
|hibernate3
 
|3.6.10
 
|
 
|{{bz|803546}}
 
|[[User:Arg|arg]]
 
|'''<span style="color:green">In Rawhide</span>'''
 
|Direct dep; also blocks ehcache
 
|-
 
|26
 
|ehcache-core
 
|2.6.0
 
|
 
|{{bz|803558}}
 
 
|[[User:gil|gil]]
 
|[[User:gil|gil]]
|'''<span style="color:green">In Rawhide</span>'''
+
|'''<span style="color:darkviolet">Skipped</span>'''
|Direct dep, blocked by hibernate3
+
|Apache Karaf deps
 
|-
 
|-
|27
+
|54
|gwt
+
|hawtbuf
|2.4.0
+
|1.9
 
|
 
|
|
+
|<s>{{bz|853050}}</s>
|[[User:Arg|arg]]
 
|'''<span style="color:red">Clean-up Required</span>'''
 
|Direct dep, blocked by hibernate-validator
 
|-
 
|28
 
|jsf implementation - Is mojarra ok?
 
|2.1.7
 
|
 
|{{bz|800890}}
 
|[[User:Jhernand|jhernand]]
 
|'''<span style="color:green">In Rawhide</span>'''
 
|Indirect dep; blocks spring-web
 
|-
 
|29
 
|apache-commons-javaflow
 
|1.0
 
|
 
|{{bz|820344}}
 
 
|[[User:gil|gil]]
 
|[[User:gil|gil]]
 
|'''<span style="color:green">In Rawhide</span>'''
 
|'''<span style="color:green">In Rawhide</span>'''
|
+
|mqtt-client deps
 
|-
 
|-
|30
+
|55
|jasperreports
+
|hawtdispatch
|4.0.2
+
|1.11
 
|
 
|
|{{bz|820548}}
+
|<s>{{bz|853052}}</s>
 
|[[User:gil|gil]]
 
|[[User:gil|gil]]
 
|'''<span style="color:green">In Rawhide</span>'''
 
|'''<span style="color:green">In Rawhide</span>'''
|
+
|mqtt-client deps
 
|-
 
|-
|31
+
|56
|apacheds
+
|oscache
|1.5.7
+
|2.4.1
 
|
 
|
|{{bz|823967}}
+
|<s>{{bz|849470}}</s>
 
|[[User:gil|gil]]
 
|[[User:gil|gil]]
|'''<span style="color:orange">Awaiting Review</span>'''
+
|'''<span style="color:darkviolet">Skipped</span>'''
|
+
|Hibernate 3.x deps (module of the same name). This package was removed from review request queue.
 
|-
 
|-
|32
+
|57
|portlet-2.0-api
+
|swarmcache
 
|1.0
 
|1.0
 
|
 
|
|{{bz|824539}}
+
|<s>{{bz|849471}}</s>
 
|[[User:gil|gil]]
 
|[[User:gil|gil]]
|'''<span style="color:green">In Rawhide</span>'''
+
|'''<span style="color:darkviolet">Skipped</span>'''
|springframework deps
+
|Hibernate 3.x deps (module of the same name). This package was removed from review request queue.
 
|-
 
|-
|33
+
|58
|jasypt
+
|activemq
|1.9.0
+
|5.6.0
 
|
 
|
|{{bz|822889}}
+
|<s>{{bz|857193}}</s>
|[[User:gil|gil]]
+
|[[User:madsa|madsa]]
|'''<span style="color:orange">Awaiting Review</span>'''
+
|'''<span style="color:green">In Rawhide</span>'''
|ActiveMQ deps
 
|-
 
|34
 
|activeio
 
|3.1.4
 
 
|
 
|
|{{bz|822920}}
 
|[[User:gil|gil]]
 
|'''<span style="color:orange">Awaiting Review</span>'''
 
|ActiveMQ deps
 
 
|-
 
|-
|35
+
|59
|activemq-protobuf
+
|classmate
|1.1
+
|0.5.4
 
|
 
|
|{{bz|822929}}
+
|<s>{{bz|815060}}</s>
 
|[[User:gil|gil]]
 
|[[User:gil|gil]]
|'''<span style="color:orange">Awaiting Review</span>'''
+
|'''<span style="color:green">In Rawhide</span>'''
|ActiveMQ deps
+
|An Hibernate 4.x dependency. module hibernate-core
 
|-
 
|-
|36
+
|60
|josql
+
|karaf
|2.2
+
|2.2.5
 
|
 
|
|{{bz|822832}}
+
|<s>{{bz|875692}}</s>
 
|[[User:gil|gil]]
 
|[[User:gil|gil]]
|'''<span style="color:orange">Awaiting Review</span>'''
+
|'''<span style="color:darkviolet">Skipped</span>'''
|ActiveMQ deps
+
|ActiveMQ deps. This package was removed from review request queue.
 
|-
 
|-
|37
+
|61
|eclipselink
+
|gemini-blueprint
|2.3.2
+
|1.0.2
 
|
 
|
|{{bz|809540}}
+
|<s>{{bz|866239}}</s>
 
|[[User:gil|gil]]
 
|[[User:gil|gil]]
 
|'''<span style="color:green">In Rawhide</span>'''
 
|'''<span style="color:green">In Rawhide</span>'''
|springframework deps
+
|ActiveMQ deps  
 
|-
 
|-
|38
+
|62
|openjpa
+
|springframework-ws
|2.2.0
+
|2.0.5.RELEASE
 
|
 
|
|{{bz|823889}}
+
|<s>{{bz|877152}}</s>
 
|[[User:gil|gil]]
 
|[[User:gil|gil]]
 
|'''<span style="color:green">In Rawhide</span>'''
 
|'''<span style="color:green">In Rawhide</span>'''
|springframework deps
+
|ActiveMQ deps  
 
|-
 
|-
|39
+
|63
|jdbm
+
|camel
|1.0
+
|2.10.4
 
|
 
|
|{{bz|844033}}
+
|{{bz|968136}}
|[[User:madsa|madsa]]
+
|[[User:gil|gil]]
 
|'''<span style="color:orange">Awaiting Review</span>'''
 
|'''<span style="color:orange">Awaiting Review</span>'''
|JBossCache deps
+
|ActiveMQ deps
|-
 
|40
 
|jgroups212
 
|2.12.3
 
|
 
|{{bz|844479}}
 
|[[User:madsa|madsa]]
 
|'''<span style="color:orange">Awaiting Review</span>'''
 
|JBossCache deps
 
 
|}
 
|}
 
The above dependencies should be enough the complete most of the required spring modules, including:
 
* spring-beans
 
* spring-context
 
* spring-context-support (see {{bz|836218}})
 
 
I have *not* determined the full list of dependencies required for spring-web, nor the transitive dependencies for myfaces-core. From the pom, it appears spring-web will need:
 
* javax.portlet:portlet-api
 
* axis2-saaj-api (but I suspect this is optional)
 
  
 
=== Optional dependencies and sub-dependencies ===
 
=== Optional dependencies and sub-dependencies ===
  
ActiveMQ and JasperReports are only necessary for reporting, which, while it's a nice new feature of Eucalyptus 3, can easily be omitted from the build.
+
Enough of ActiveMQ is built for Eucalyptus to function.  Packages mentioned here are only necessary to activate more of the activemq modules.
  
Infinispan dependencies
+
ActiveMQ 5.6.0 dependencies:
* rhq
+
* activesoap jaxp-api (replace with glassfish-jaxb-api)
 
+
* annogen
ActiveMQ 5 dependencies:
+
* apache-commons-primitives
 +
* apacheds
 +
* camel 2.9.2 or major, http://camel.apache.org/ (required modules: camel-core, camel-jetty, camel-jms, camel-spring)
 
* easymock-classextension
 
* easymock-classextension
* spring 2
+
* gentlyweb-utils
* apacheds
+
* groovy-gram
* xbean 3.7 or major (maven-xbean-plugin and xbean-spring modules)
+
* TODO jrms
 +
* mqtt-client
 +
* karaf, module org.apache.karaf.shell.console
 +
* TODO fuse-extra (module fusemq-leveldb)
 +
* TODO pax-exam 1.x
 +
* pax-logging
 +
* sitemesh 2.4.2
 +
* gemini-blueprint see http://www.springsource.org/osgi (spring-osgi).
 +
* springframework-ws
 +
* xbean 3.9 or major: maven-xbean-plugin, TODO xbean-blueprint (see {{bz|849955}}) and xbean-spring modules
 
* etc. (I am unsure of the full dep chain at this time
 
* etc. (I am unsure of the full dep chain at this time
 
JasperReports dependencies:
 
* castor (castor-core and castor-xml modules) see {{bz|820676}}
 
* barcode4j
 
* eigenbase-properties (for mondrian)
 
* eigenbase-resgen (for mondrian)
 
* jexcelapi
 
* olap4j (for mondrian)
 
* TODO: mondrian
 
* apache-commons-javaflow
 
* TODO: png-encoder
 
* TODO: barbecue
 
* TODO: jdt-compiler (is this already in as part of eclipse?? ecj >= 1:3.4.2-13)
 
* hibernate 3.x
 

Latest revision as of 11:54, 4 September 2016

This page is for tracking progress on the packaging Eucalyptus 3.x in Fedora. We've been tracking this for three releases now, and the dependency packaging is mostly complete, except for Google Web Toolkit, which we can omit for now. Therefore, it's more useful for the top of this page to summarize the _other_ changes needed to make Eucalyptus build and run on Fedora 18.

Remaining tasks

Polish systemd units for eucalyptus services

There are three init scripts in eucalyptus:

  • eucalyptus-cloud - starts a java service, which may be a Cloud Controller, Walrus, or Storage Controller
  • eucalyptus-cc - starts a Cluster Controller (CC), which is a custom httpd instance with wso2-axis2 configured
  • eucalyptus-nc - starts a Node Controller (NC), which is a custom httpd instance with wso2-axis2 configured

In Fedora 18, we provide systemd units which simple execute the old init scripts, which have been moved to /usr/libexec/eucalyptus. Ideally, the old init scripts should go away completely.

Create SELinux contexts/policies

Eucalyptus must run in permissive mode in Fedora 18. We need to work on policy that will allow it to run in enforcing mode.

Make Axis2/Java 1.6 work for code generation

The C code generated by Axis2/Java 1.6.0 does not work with Eucalyptus's currently defined handlers. Currently, one must use an Axis2/Java 1.4 package to build a tarball of generated code for inclusion in the eucalyptus package.

Fix the reporting module

There is a build issue in the reporting module due to the use of Guava 9 in the upstream Eucalyptus build. For now, the module has been disabled.

Enable the admin console

The admin console is based on GWT, which is not yet in Fedora. It may not be worth the time to build it, though, as Eucalyptus intends to phase out the GWT-based UI.

Packaging Progress

These are the packages still in progress which are necessary for the Eucalyptus build:

# Package Version POM Review request Packager Status Comments
27 gwt 2.4.0 arg Clean-up Required Required for admin console
36 josql 2.2 RHBZ #822832 gil In Rawhide ActiveMQ deps
47 mqtt-client 1.3 RHBZ #853055 gil In Rawhide ActiveMQ deps
48 groovy-gram 1.2 RHBZ #846561 gil Awaiting Review ActiveMQ deps
49 pax-logging 1.6.9 RHBZ #849469 gil In Rawhide ActiveMQ deps
50 sitemesh 2.4.2 RHBZ #853439 gil Skipped ActiveMQ deps. This package was removed from review request queue.
51 apache-commons-primitives 1.1 RHBZ #832803 gil In Rawhide ActiveMQ deps
52 felix-fileinstall 3.2.0 RHBZ #855192 gil In Rawhide Apache Karaf deps
53 felix-webconsole 4.0.0 RHBZ #855193 gil Skipped Apache Karaf deps
54 hawtbuf 1.9 RHBZ #853050 gil In Rawhide mqtt-client deps
55 hawtdispatch 1.11 RHBZ #853052 gil In Rawhide mqtt-client deps
56 oscache 2.4.1 RHBZ #849470 gil Skipped Hibernate 3.x deps (module of the same name). This package was removed from review request queue.
57 swarmcache 1.0 RHBZ #849471 gil Skipped Hibernate 3.x deps (module of the same name). This package was removed from review request queue.
58 activemq 5.6.0 RHBZ #857193 madsa In Rawhide
59 classmate 0.5.4 RHBZ #815060 gil In Rawhide An Hibernate 4.x dependency. module hibernate-core
60 karaf 2.2.5 RHBZ #875692 gil Skipped ActiveMQ deps. This package was removed from review request queue.
61 gemini-blueprint 1.0.2 RHBZ #866239 gil In Rawhide ActiveMQ deps
62 springframework-ws 2.0.5.RELEASE RHBZ #877152 gil In Rawhide ActiveMQ deps
63 camel 2.10.4 RHBZ #968136 gil Awaiting Review ActiveMQ deps

Optional dependencies and sub-dependencies

Enough of ActiveMQ is built for Eucalyptus to function. Packages mentioned here are only necessary to activate more of the activemq modules.

ActiveMQ 5.6.0 dependencies:

  • activesoap jaxp-api (replace with glassfish-jaxb-api)
  • annogen
  • apache-commons-primitives
  • apacheds
  • camel 2.9.2 or major, http://camel.apache.org/ (required modules: camel-core, camel-jetty, camel-jms, camel-spring)
  • easymock-classextension
  • gentlyweb-utils
  • groovy-gram
  • TODO jrms
  • mqtt-client
  • karaf, module org.apache.karaf.shell.console
  • TODO fuse-extra (module fusemq-leveldb)
  • TODO pax-exam 1.x
  • pax-logging
  • sitemesh 2.4.2
  • gemini-blueprint see http://www.springsource.org/osgi (spring-osgi).
  • springframework-ws
  • xbean 3.9 or major: maven-xbean-plugin, TODO xbean-blueprint (see RHBZ #849955) and xbean-spring modules
  • etc. (I am unsure of the full dep chain at this time